import multiprocessing as mp
import alive_progress
import sqlite3
import cv2 as cv
import numpy as np
import functions
import asyncio
from humanfriendly import format_timespan
from timeit import default_timer as timer

# config
chunk_size = 100000

# create image
img = np.zeros((2000, 2000, 3), np.uint8)
img.fill(255)

def loadPixels():
    # connect to database
    print("connecting to database...")
    con = sqlite3.connect('data/data.db')
    cur = con.cursor()

    line_count = 0
    start_time = timer()
    for i in range(0, 1000):
        offset = i * chunk_size

        # load data
        with alive_progress.alive_bar(title=f"loading data \t{offset} - {offset + chunk_size}\t") as bar:
            data = cur.execute(f'SELECT * FROM place ORDER BY time ASC LIMIT {chunk_size} OFFSET {offset}')
            bar()

        # draw
        with alive_progress.alive_bar(chunk_size, title=f"processing \t{offset} - {offset + chunk_size}\t") as bar:
            for row in data:
                img[row[2]][row[1]] = functions.hexToRgb(row[0])
                line_count += 1
                bar()

        cv.imwrite(f"img/place{str(offset + chunk_size).zfill(12)}.png", img)


    # close connection
    print("closing connection")
    con.close()

    # show stats
    end_time = timer()
    print(f"{line_count} tiles in {format_timespan(end_time - start_time)}")


async def show():
    i = cv.imread("img.png")
    # resize image
    resized = cv.resize(i, (1000, 1000), cv.INTER_NEAREST)
    cv.imshow('very cool window', resized)

    # wait
    cv.waitKey(0)

loadPixels()
